import numpy as np
from sklearn.datasets import load_iris
from sklearn.model_selection import train_test_split
from sklearn.metrics import accuracy_score
from logistic_regression import Logistic_Regression

if __name__ == '__main__':
    X, y = load_iris(return_X_y=True)
    # 归一化
    X = (X - X.min(axis=0)) / (X.max(axis=0) - X.min(axis=0))
    # 线性模型加上偏置b
    X = np.c_[np.ones((len(X), 1)), X]
    # 将数据集分为训练集和测试集
    X_train, X_test, y_train, y_test = train_test_split(X, y)

 
    model = Logistic_Regression(epochs=300)
    model.fit(X_train, y_train)
    y_pred = model.predict(X_test)
    score = accuracy_score(y_test, y_pred)
    print('classificator of Logistic_Regression score is {:.3f}'.format(score))